/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSAbstractView.h"

#include "DOMWindow.h"
#include "Document.h"
#include "JSDOMBinding.h"
#include "JSDocument.h"
#include "JSStyleMedia.h"
#include "ScriptExecutionContext.h"
#include "StyleMedia.h"
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Attributes

JSC::EncodedJSValue jsAbstractViewDocument(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsAbstractViewStyleMedia(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);

class JSAbstractViewPrototype : public JSC::JSNonFinalObject {
public:
    typedef JSC::JSNonFinalObject Base;
    static JSAbstractViewPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSAbstractViewPrototype* ptr = new (NotNull, JSC::allocateCell<JSAbstractViewPrototype>(vm.heap)) JSAbstractViewPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSAbstractViewPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

/* Hash table for prototype */

static const HashTableValue JSAbstractViewPrototypeTableValues[] =
{
    { "document", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAbstractViewDocument), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "styleMedia", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAbstractViewStyleMedia), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSAbstractViewPrototype::s_info = { "AbstractViewPrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSAbstractViewPrototype) };

void JSAbstractViewPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSAbstractViewPrototypeTableValues, *this);
}

const ClassInfo JSAbstractView::s_info = { "AbstractView", &Base::s_info, 0, CREATE_METHOD_TABLE(JSAbstractView) };

JSAbstractView::JSAbstractView(Structure* structure, JSDOMGlobalObject* globalObject, Ref<DOMWindow>&& impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(&impl.leakRef())
{
}

JSObject* JSAbstractView::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSAbstractViewPrototype::create(vm, globalObject, JSAbstractViewPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

JSObject* JSAbstractView::getPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSAbstractView>(vm, globalObject);
}

void JSAbstractView::destroy(JSC::JSCell* cell)
{
    JSAbstractView* thisObject = static_cast<JSAbstractView*>(cell);
    thisObject->JSAbstractView::~JSAbstractView();
}

JSAbstractView::~JSAbstractView()
{
    releaseImpl();
}

EncodedJSValue jsAbstractViewDocument(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSAbstractView* castedThis = jsDynamicCast<JSAbstractView*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSAbstractViewPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "AbstractView", "document");
        return throwGetterTypeError(*exec, "AbstractView", "document");
    }
    auto& impl = castedThis->impl();
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.document()));
    return JSValue::encode(result);
}


EncodedJSValue jsAbstractViewStyleMedia(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSAbstractView* castedThis = jsDynamicCast<JSAbstractView*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSAbstractViewPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "AbstractView", "styleMedia");
        return throwGetterTypeError(*exec, "AbstractView", "styleMedia");
    }
    auto& impl = castedThis->impl();
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.styleMedia()));
    return JSValue::encode(result);
}


bool JSAbstractViewOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSAbstractViewOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsAbstractView = jsCast<JSAbstractView*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsAbstractView->impl(), jsAbstractView);
}

DOMWindow* JSAbstractView::toWrapped(JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSAbstractView*>(value))
        return &wrapper->impl();
    return nullptr;
}

}
