/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSEntityReference.h"

#include "EntityReference.h"
#include "JSDOMBinding.h"
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Attributes

JSC::EncodedJSValue jsEntityReferenceConstructor(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);

class JSEntityReferencePrototype : public JSC::JSNonFinalObject {
public:
    typedef JSC::JSNonFinalObject Base;
    static JSEntityReferencePrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSEntityReferencePrototype* ptr = new (NotNull, JSC::allocateCell<JSEntityReferencePrototype>(vm.heap)) JSEntityReferencePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSEntityReferencePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

class JSEntityReferenceConstructor : public DOMConstructorObject {
private:
    JSEntityReferenceConstructor(JSC::Structure*, JSDOMGlobalObject*);
    void finishCreation(JSC::VM&, JSDOMGlobalObject*);

public:
    typedef DOMConstructorObject Base;
    static JSEntityReferenceConstructor* create(JSC::VM& vm, JSC::Structure* structure, JSDOMGlobalObject* globalObject)
    {
        JSEntityReferenceConstructor* ptr = new (NotNull, JSC::allocateCell<JSEntityReferenceConstructor>(vm.heap)) JSEntityReferenceConstructor(structure, globalObject);
        ptr->finishCreation(vm, globalObject);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }
};

const ClassInfo JSEntityReferenceConstructor::s_info = { "EntityReferenceConstructor", &Base::s_info, 0, CREATE_METHOD_TABLE(JSEntityReferenceConstructor) };

JSEntityReferenceConstructor::JSEntityReferenceConstructor(Structure* structure, JSDOMGlobalObject* globalObject)
    : DOMConstructorObject(structure, globalObject)
{
}

void JSEntityReferenceConstructor::finishCreation(VM& vm, JSDOMGlobalObject* globalObject)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
    putDirect(vm, vm.propertyNames->prototype, JSEntityReference::getPrototype(vm, globalObject), DontDelete | ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("EntityReference"))), ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontEnum);
}

/* Hash table for prototype */

static const HashTableValue JSEntityReferencePrototypeTableValues[] =
{
    { "constructor", DontEnum | ReadOnly, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsEntityReferenceConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSEntityReferencePrototype::s_info = { "EntityReferencePrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSEntityReferencePrototype) };

void JSEntityReferencePrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSEntityReferencePrototypeTableValues, *this);
}

const ClassInfo JSEntityReference::s_info = { "EntityReference", &Base::s_info, 0, CREATE_METHOD_TABLE(JSEntityReference) };

JSEntityReference::JSEntityReference(Structure* structure, JSDOMGlobalObject* globalObject, Ref<EntityReference>&& impl)
    : JSNode(structure, globalObject, WTF::move(impl))
{
}

JSObject* JSEntityReference::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSEntityReferencePrototype::create(vm, globalObject, JSEntityReferencePrototype::createStructure(vm, globalObject, JSNode::getPrototype(vm, globalObject)));
}

JSObject* JSEntityReference::getPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSEntityReference>(vm, globalObject);
}

EncodedJSValue jsEntityReferenceConstructor(ExecState* exec, JSObject* baseValue, EncodedJSValue, PropertyName)
{
    JSEntityReferencePrototype* domObject = jsDynamicCast<JSEntityReferencePrototype*>(baseValue);
    if (!domObject)
        return throwVMTypeError(exec);
    return JSValue::encode(JSEntityReference::getConstructor(exec->vm(), domObject->globalObject()));
}

JSValue JSEntityReference::getConstructor(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSEntityReferenceConstructor>(vm, jsCast<JSDOMGlobalObject*>(globalObject));
}


}
