/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(USER_MESSAGE_HANDLERS)

#include "JSUserMessageHandler.h"

#include "ExceptionCode.h"
#include "JSDOMBinding.h"
#include "SerializedScriptValue.h"
#include "UserMessageHandler.h"
#include <runtime/Error.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsUserMessageHandlerPrototypeFunctionPostMessage(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsUserMessageHandlerConstructor(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);

class JSUserMessageHandlerPrototype : public JSC::JSNonFinalObject {
public:
    typedef JSC::JSNonFinalObject Base;
    static JSUserMessageHandlerPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSUserMessageHandlerPrototype* ptr = new (NotNull, JSC::allocateCell<JSUserMessageHandlerPrototype>(vm.heap)) JSUserMessageHandlerPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSUserMessageHandlerPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

class JSUserMessageHandlerConstructor : public DOMConstructorObject {
private:
    JSUserMessageHandlerConstructor(JSC::Structure*, JSDOMGlobalObject*);
    void finishCreation(JSC::VM&, JSDOMGlobalObject*);

public:
    typedef DOMConstructorObject Base;
    static JSUserMessageHandlerConstructor* create(JSC::VM& vm, JSC::Structure* structure, JSDOMGlobalObject* globalObject)
    {
        JSUserMessageHandlerConstructor* ptr = new (NotNull, JSC::allocateCell<JSUserMessageHandlerConstructor>(vm.heap)) JSUserMessageHandlerConstructor(structure, globalObject);
        ptr->finishCreation(vm, globalObject);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }
};

const ClassInfo JSUserMessageHandlerConstructor::s_info = { "UserMessageHandlerConstructor", &Base::s_info, 0, CREATE_METHOD_TABLE(JSUserMessageHandlerConstructor) };

JSUserMessageHandlerConstructor::JSUserMessageHandlerConstructor(Structure* structure, JSDOMGlobalObject* globalObject)
    : DOMConstructorObject(structure, globalObject)
{
}

void JSUserMessageHandlerConstructor::finishCreation(VM& vm, JSDOMGlobalObject* globalObject)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
    putDirect(vm, vm.propertyNames->prototype, JSUserMessageHandler::getPrototype(vm, globalObject), DontDelete | ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("UserMessageHandler"))), ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontEnum);
}

/* Hash table for prototype */

static const HashTableValue JSUserMessageHandlerPrototypeTableValues[] =
{
    { "constructor", DontEnum | ReadOnly, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsUserMessageHandlerConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "postMessage", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsUserMessageHandlerPrototypeFunctionPostMessage), (intptr_t) (1) } },
};

const ClassInfo JSUserMessageHandlerPrototype::s_info = { "UserMessageHandlerPrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSUserMessageHandlerPrototype) };

void JSUserMessageHandlerPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSUserMessageHandlerPrototypeTableValues, *this);
}

const ClassInfo JSUserMessageHandler::s_info = { "UserMessageHandler", &Base::s_info, 0, CREATE_METHOD_TABLE(JSUserMessageHandler) };

JSUserMessageHandler::JSUserMessageHandler(Structure* structure, JSDOMGlobalObject* globalObject, Ref<UserMessageHandler>&& impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(&impl.leakRef())
{
}

JSObject* JSUserMessageHandler::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSUserMessageHandlerPrototype::create(vm, globalObject, JSUserMessageHandlerPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

JSObject* JSUserMessageHandler::getPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSUserMessageHandler>(vm, globalObject);
}

void JSUserMessageHandler::destroy(JSC::JSCell* cell)
{
    JSUserMessageHandler* thisObject = static_cast<JSUserMessageHandler*>(cell);
    thisObject->JSUserMessageHandler::~JSUserMessageHandler();
}

JSUserMessageHandler::~JSUserMessageHandler()
{
    releaseImpl();
}

EncodedJSValue jsUserMessageHandlerConstructor(ExecState* exec, JSObject* baseValue, EncodedJSValue, PropertyName)
{
    JSUserMessageHandlerPrototype* domObject = jsDynamicCast<JSUserMessageHandlerPrototype*>(baseValue);
    if (!domObject)
        return throwVMTypeError(exec);
    return JSValue::encode(JSUserMessageHandler::getConstructor(exec->vm(), domObject->globalObject()));
}

JSValue JSUserMessageHandler::getConstructor(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSUserMessageHandlerConstructor>(vm, jsCast<JSDOMGlobalObject*>(globalObject));
}

EncodedJSValue JSC_HOST_CALL jsUserMessageHandlerPrototypeFunctionPostMessage(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSUserMessageHandler* castedThis = jsDynamicCast<JSUserMessageHandler*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "UserMessageHandler", "postMessage");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSUserMessageHandler::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    ExceptionCode ec = 0;
    RefPtr<SerializedScriptValue> message = SerializedScriptValue::create(exec, exec->argument(0), 0, 0);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.postMessage(message, ec);
    setDOMException(exec, ec);
    return JSValue::encode(jsUndefined());
}

bool JSUserMessageHandlerOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSUserMessageHandlerOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsUserMessageHandler = jsCast<JSUserMessageHandler*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsUserMessageHandler->impl(), jsUserMessageHandler);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7UserMessageHandler@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore18UserMessageHandlerE[]; }
#endif
#endif
JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject* globalObject, UserMessageHandler* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSUserMessageHandler>(globalObject, impl))
        return result;

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7UserMessageHandler@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore18UserMessageHandlerE[2];
#if COMPILER(CLANG)
    // If this fails UserMessageHandler does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    COMPILE_ASSERT(__is_polymorphic(UserMessageHandler), UserMessageHandler_is_not_polymorphic);
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // UserMessageHandler has subclasses. If UserMessageHandler has subclasses that get passed
    // to toJS() we currently require UserMessageHandler you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createNewWrapper<JSUserMessageHandler>(globalObject, impl);
}

UserMessageHandler* JSUserMessageHandler::toWrapped(JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSUserMessageHandler*>(value))
        return &wrapper->impl();
    return nullptr;
}

}

#endif // ENABLE(USER_MESSAGE_HANDLERS)
