/*
 *  This file is part of the WebKit open source project.
 *  This file has been generated by generate-bindings.pl. DO NOT MODIFY!
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this library; see the file COPYING.LIB.  If not, write to
 *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 */

#include "config.h"
#include "WebKitDOMHTMLBaseFontElement.h"

#include "CSSImportRule.h"
#include "DOMObjectCache.h"
#include "Document.h"
#include "ExceptionCode.h"
#include "ExceptionCodeDescription.h"
#include "HTMLNames.h"
#include "JSMainThreadExecState.h"
#include "WebKitDOMHTMLBaseFontElementPrivate.h"
#include "WebKitDOMNodePrivate.h"
#include "WebKitDOMPrivate.h"
#include "gobject/ConvertToUTF8String.h"
#include <wtf/GetPtr.h>
#include <wtf/RefPtr.h>

namespace WebKit {

WebKitDOMHTMLBaseFontElement* kit(WebCore::HTMLBaseFontElement* obj)
{
    return WEBKIT_DOM_HTML_BASE_FONT_ELEMENT(kit(static_cast<WebCore::Node*>(obj)));
}

WebCore::HTMLBaseFontElement* core(WebKitDOMHTMLBaseFontElement* request)
{
    return request ? static_cast<WebCore::HTMLBaseFontElement*>(WEBKIT_DOM_OBJECT(request)->coreObject) : 0;
}

WebKitDOMHTMLBaseFontElement* wrapHTMLBaseFontElement(WebCore::HTMLBaseFontElement* coreObject)
{
    ASSERT(coreObject);
    return WEBKIT_DOM_HTML_BASE_FONT_ELEMENT(g_object_new(WEBKIT_DOM_TYPE_HTML_BASE_FONT_ELEMENT, "core-object", coreObject, nullptr));
}

} // namespace WebKit

G_DEFINE_TYPE(WebKitDOMHTMLBaseFontElement, webkit_dom_html_base_font_element, WEBKIT_DOM_TYPE_HTML_ELEMENT)

enum {
    PROP_0,
    PROP_COLOR,
    PROP_FACE,
    PROP_SIZE,
};

static void webkit_dom_html_base_font_element_set_property(GObject* object, guint propertyId, const GValue* value, GParamSpec* pspec)
{
    WebKitDOMHTMLBaseFontElement* self = WEBKIT_DOM_HTML_BASE_FONT_ELEMENT(object);

    switch (propertyId) {
    case PROP_COLOR:
        webkit_dom_html_base_font_element_set_color(self, g_value_get_string(value));
        break;
    case PROP_FACE:
        webkit_dom_html_base_font_element_set_face(self, g_value_get_string(value));
        break;
    case PROP_SIZE:
        webkit_dom_html_base_font_element_set_size(self, g_value_get_long(value));
        break;
    default:
        G_OBJECT_WARN_INVALID_PROPERTY_ID(object, propertyId, pspec);
        break;
    }
}

static void webkit_dom_html_base_font_element_get_property(GObject* object, guint propertyId, GValue* value, GParamSpec* pspec)
{
    WebKitDOMHTMLBaseFontElement* self = WEBKIT_DOM_HTML_BASE_FONT_ELEMENT(object);

    switch (propertyId) {
    case PROP_COLOR:
        g_value_take_string(value, webkit_dom_html_base_font_element_get_color(self));
        break;
    case PROP_FACE:
        g_value_take_string(value, webkit_dom_html_base_font_element_get_face(self));
        break;
    case PROP_SIZE:
        g_value_set_long(value, webkit_dom_html_base_font_element_get_size(self));
        break;
    default:
        G_OBJECT_WARN_INVALID_PROPERTY_ID(object, propertyId, pspec);
        break;
    }
}

static void webkit_dom_html_base_font_element_class_init(WebKitDOMHTMLBaseFontElementClass* requestClass)
{
    GObjectClass* gobjectClass = G_OBJECT_CLASS(requestClass);
    gobjectClass->set_property = webkit_dom_html_base_font_element_set_property;
    gobjectClass->get_property = webkit_dom_html_base_font_element_get_property;

    g_object_class_install_property(
        gobjectClass,
        PROP_COLOR,
        g_param_spec_string(
            "color",
            "HTMLBaseFontElement:color",
            "read-write gchar* HTMLBaseFontElement:color",
            "",
            WEBKIT_PARAM_READWRITE));

    g_object_class_install_property(
        gobjectClass,
        PROP_FACE,
        g_param_spec_string(
            "face",
            "HTMLBaseFontElement:face",
            "read-write gchar* HTMLBaseFontElement:face",
            "",
            WEBKIT_PARAM_READWRITE));

    g_object_class_install_property(
        gobjectClass,
        PROP_SIZE,
        g_param_spec_long(
            "size",
            "HTMLBaseFontElement:size",
            "read-write glong HTMLBaseFontElement:size",
            G_MINLONG, G_MAXLONG, 0,
            WEBKIT_PARAM_READWRITE));

}

static void webkit_dom_html_base_font_element_init(WebKitDOMHTMLBaseFontElement* request)
{
    UNUSED_PARAM(request);
}

gchar* webkit_dom_html_base_font_element_get_color(WebKitDOMHTMLBaseFontElement* self)
{
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_HTML_BASE_FONT_ELEMENT(self), 0);
    WebCore::HTMLBaseFontElement* item = WebKit::core(self);
    gchar* result = convertToUTF8String(item->fastGetAttribute(WebCore::HTMLNames::colorAttr));
    return result;
}

void webkit_dom_html_base_font_element_set_color(WebKitDOMHTMLBaseFontElement* self, const gchar* value)
{
    WebCore::JSMainThreadNullState state;
    g_return_if_fail(WEBKIT_DOM_IS_HTML_BASE_FONT_ELEMENT(self));
    g_return_if_fail(value);
    WebCore::HTMLBaseFontElement* item = WebKit::core(self);
    WTF::String convertedValue = WTF::String::fromUTF8(value);
    item->setAttributeWithoutSynchronization(WebCore::HTMLNames::colorAttr, convertedValue);
}

gchar* webkit_dom_html_base_font_element_get_face(WebKitDOMHTMLBaseFontElement* self)
{
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_HTML_BASE_FONT_ELEMENT(self), 0);
    WebCore::HTMLBaseFontElement* item = WebKit::core(self);
    gchar* result = convertToUTF8String(item->fastGetAttribute(WebCore::HTMLNames::faceAttr));
    return result;
}

void webkit_dom_html_base_font_element_set_face(WebKitDOMHTMLBaseFontElement* self, const gchar* value)
{
    WebCore::JSMainThreadNullState state;
    g_return_if_fail(WEBKIT_DOM_IS_HTML_BASE_FONT_ELEMENT(self));
    g_return_if_fail(value);
    WebCore::HTMLBaseFontElement* item = WebKit::core(self);
    WTF::String convertedValue = WTF::String::fromUTF8(value);
    item->setAttributeWithoutSynchronization(WebCore::HTMLNames::faceAttr, convertedValue);
}

glong webkit_dom_html_base_font_element_get_size(WebKitDOMHTMLBaseFontElement* self)
{
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_HTML_BASE_FONT_ELEMENT(self), 0);
    WebCore::HTMLBaseFontElement* item = WebKit::core(self);
    glong result = item->getIntegralAttribute(WebCore::HTMLNames::sizeAttr);
    return result;
}

void webkit_dom_html_base_font_element_set_size(WebKitDOMHTMLBaseFontElement* self, glong value)
{
    WebCore::JSMainThreadNullState state;
    g_return_if_fail(WEBKIT_DOM_IS_HTML_BASE_FONT_ELEMENT(self));
    WebCore::HTMLBaseFontElement* item = WebKit::core(self);
    item->setIntegralAttribute(WebCore::HTMLNames::sizeAttr, value);
}

